package com.hello2morrow.sonargraph.languageprovider.java.command.system.scripts.java

import static org.junit.Assert.*

import com.hello2morrow.sonargraph.core.model.element.Element
import com.hello2morrow.sonargraph.core.model.script.GroovyScript
import com.hello2morrow.sonargraph.core.model.script.ScriptNamedTreeNode
import com.hello2morrow.sonargraph.core.model.script.ScriptResultSet
import com.hello2morrow.sonargraph.languageprovider.java.command.system.scripts.AbstractJavaScriptTest
import com.hello2morrow.sonargraph.languageprovider.java.foundation.common.JavaTestFixture
import com.hello2morrow.sonargraph.languageprovider.java.model.programming.JavaInternalCompilationUnit

class AcdTopScorerScriptTest extends AbstractJavaScriptTest {
    private static final String SCRIPT_PATH = JavaTestFixture.SCRIPT_ACD_TOP_SCORER_SCRIPT_PATH;
    private static final String PROJECT_PATH = JavaTestFixture.SCRIPT_FIND_SYNCHRONIZED_METHODS_PROJECT_PATH;

    public AcdTopScorerScriptTest() {
        super(PROJECT_PATH, SCRIPT_PATH);
    }

    @Override
    void verifyResult(GroovyScript script) {
        ScriptResultSet result = script.getResultSet();
        assertEquals("Wrong number of children", 10, result.getTreeRootNode().getChildren().size());
        List<ScriptNamedTreeNode> children = result.getTreeRootNode().getChildren();
        ScriptNamedTreeNode summary = children.get(0);
        assertEquals("Wrong summary", "Max 'depends upon': 3 - max 'used from': 2 -  analyzed 3 source files", summary.getName());
        ScriptNamedTreeNode relImpact9 = children.get(1);
        Element element = relImpact9.getChildren().get(0).getElement();

        assertTrue("Wrong class: " + element.getClass().getName(), element instanceof JavaInternalCompilationUnit);
        assertEquals("Wrong element: " + element.toString(), "com.hello2morrow.sonargraph.languageprovider.java.model.programming.JavaInternalCompilationUnit: ./com/hello2morrow/synmethtest/CounterThread.java (CounterThread.java)", element.toString());
    }
}